function cov_mat = tidy_cov_mat(m)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Sometimes, due to machine error, the calculated covariance matrix is
% no positive definite and symmetric.  This will fix that.  It is a way to
% make the code more robust but it should be checked to see if changes are
% being made that matter.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cov_mat = tril(m, -1);
cov_mat = cov_mat + diag(diag(m)) + cov_mat';
[V,D] = eig(cov_mat);
d=diag(D);
d(d<=eps) = eps * 10;
a = V * diag(d) * V';
cov_mat = tril(a, -1);
cov_mat = cov_mat + diag(diag(a)) + cov_mat';